//-------------------------
//filepack.c
//-------------------------

#include <string.h>
#include <stdlib.h>
#include <piece.h>
#include <ctype.h>

#define DWORD_CHAR(ch0, ch1, ch2, ch3)								\
				(((DWORD)(BYTE)(ch0) << 24) | ((DWORD)(BYTE)(ch1) << 16) |	 \
				 ((DWORD)(BYTE)(ch2) <<  8) | ((DWORD)(BYTE)(ch3)	   ))

typedef struct {
	unsigned long	head;												//	pbNwb_
	long			famount;											//	t@C
}FILE_PAC_INFO;

typedef struct {
	char			fname[32];											//	t@CigqA'\0'܂݂16܂Łj
	unsigned long	offset;												//	ItZbgAhX
	unsigned long	size;												//	t@CTCY
}FILE_INFO;

BYTE filetmp[4096];

//-------------------------------------------------------
//	p啶Aɕϊ
//-------------------------------------------------------
static void strlower( char *str )
{
	while( *str ){
		*str = (char)tolower( *str );
		str++;
	}

}

//-------------------------------------------------------
//	r
//-------------------------------------------------------
static int strcmpUL( char *str1, char *str2 )
{
	char	buf1[256], buf2[256];
	strcpy( buf1, str1 );
	strcpy( buf2, str2 );
	strlower( buf1 );
	strlower( buf2 );
	return strcmp( buf1, buf2 );
}

//-------------------------------------------------------
// header 擾
//-------------------------------------------------------

BYTE* get_file_ptr(const char *filename){
	FILEACC fa;
	
	if(pceFileOpen(&fa, filename, FOMD_RD)){
		return 0;
	}
	
	pceFileReadSct(&fa,NULL,0,0);
	
	pceFileClose(&fa);
	
	return (BYTE*)fa.aptr;
}

BYTE* get_packfile_ptr(const char *filename){
	BYTE* p = get_file_ptr(filename);
	FILE_PAC_INFO	*fpi = (FILE_PAC_INFO *)p;
	if( p==NULL ) return NULL;
	if( fpi->head!=DWORD_CHAR('F','P','K','X') ) return NULL;
	return p;
}

FILE_PAC_INFO* get_packfile_header(char* packfile){
	return (FILE_PAC_INFO*)get_packfile_ptr(packfile);
}

//ł͂ȂBAƂ肠ōς܂
FILE_INFO* get_packfile_info(char* pack_file, char* fname){
	
	BYTE			*pack_data = get_packfile_ptr(pack_file);
	FILE_PAC_INFO	*fpi = (FILE_PAC_INFO *)pack_data;
	FILE_INFO		*fi;
	int				count;

	if( pack_data==NULL ) return NULL;
	
	pack_data += sizeof(FILE_PAC_INFO);

	count = 0;
	while( count<fpi->famount ){
		fi = (FILE_INFO *)pack_data;
		if( !strcmpUL( fi->fname, fname ) ){
			return fi;
		}
		pack_data += sizeof(FILE_INFO);
		count++;
	}
	
	return NULL;

}

//t@CɓǂށBimj
BOOL _FileReadSub(FILEACC* pfa, BYTE* ptr, int pos, int len)
{
	int sct, size, firstskip;
	
	sct = pos / 4096;
	len += pos % 4096;
	firstskip = pos % 4096;

	while(len>0){
		size = (len > 4096) ? 4096 : len;
		if(pceFileReadSct(pfa, filetmp, sct, size) != size){
			return FALSE;
		}
		
		memcpy(ptr,filetmp+firstskip,size-firstskip);
		firstskip=0;
		
		sct++;
		len -= size;
		ptr += size;
	}
	return TRUE;
}

DWORD FPK_GetPackFileData(
	char *pack_file,
	char *fname,
	BYTE* p,
	DWORD offs,
	DWORD size )
{
	unsigned char	*root_ptr = get_packfile_ptr(pack_file);
	FILE_INFO		*fi = get_packfile_info(pack_file,fname);
	FILEACC fa;

	if( fi==NULL ) return 0;
	if( root_ptr==NULL ) return 0;
	//bdl
	if( size < fi->size ) return 0;

	if(pceFileOpen(&fa, pack_file, FOMD_RD)){
		return 0;
	}
	
	_FileReadSub(&fa,p,offs+fi->offset,fi->size);
	
	pceFileClose(&fa);
	
	return fi->size;
}


BOOL FPK_FindPackData(
	char *pack_file,	// pack data
	char *fname,		// target file name
	BYTE** p,			// pointer
	DWORD* size )		// file size
{
	unsigned char	*root_ptr = get_packfile_ptr(pack_file);
	FILE_INFO		*fi = get_packfile_info(pack_file,fname);

	if( fi==NULL ) return FALSE;
	if( root_ptr==NULL ) return FALSE;

	*p = root_ptr+fi->offset;
	*size = fi->size;
	
	return TRUE;
}


BOOL FPK_PackedFileNum(
	char *pack_file,	// pack file name
	int* num )		// num
{
	FILE_PAC_INFO	*fpi;
	
	*num = 0;
	
	fpi = (FILE_PAC_INFO *)get_packfile_ptr(pack_file);
	
	if( fpi==NULL ) return FALSE;
	
	*num = fpi->famount;
	
	return TRUE;
}

const char* FPK_FileNameIndex(
	char *pack_file,
	int num )
{
	BYTE			*pack_data = get_packfile_ptr(pack_file);
//	unsigned char	*root_ptr = pack_data;
	FILE_INFO		*fi;
	int				count;
	
	if( pack_data==NULL ) return NULL;
	
	pack_data += sizeof(FILE_PAC_INFO);

	count = 0;
	while( count<num ){
		pack_data += sizeof(FILE_INFO);
		count++;
	}
	
	fi = (FILE_INFO *)pack_data;
	if(count==num){
		return fi->fname;
	}
	
	return NULL;
}
